--
-- Author: Martin Fabik (aka LoogleCZ)
--
-- version ID   - 1.0
-- version date - 13.3.2016 (12:45)
-- 
-- Free for non-comerecial usage
--
--[[
]]--

PumaEffects = {};


function PumaEffects.prerequisitesPresent(specializations)
	return true;
end;

function PumaEffects:load(savegame)
  self.Puma = {};
  self.Puma.emittTime = 0;
  self.Puma.motorStartPS = {};
  PumaEffects.Puma = self.Puma;
  PumaEffects.Puma.emittTime = self.Puma.emittTime;
  PumaEffects.Puma.motorStartPS = self.Puma.motorStartPS;
  
  
	Utils.loadParticleSystem(self.xmlFile, self.Puma.motorStartPS, "vehicle.StartParticleSystem", self.components, false, nil, self.baseDirectory);
	self.Puma.allowedEmittTime = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.StartParticleSystem#startOffset"),0.1)*1000;

end;

function PumaEffects:delete()
	Utils.deleteParticleSystem(self.Puma.motorStartPS);
end;

function PumaEffects:writeStream(streamId, connection)
end;

function PumaEffects:readStream(streamId, connection)
end;

function PumaEffects:mouseEvent(posX, posY, isDown, isUp, button)
end;

function PumaEffects:keyEvent(unicode, sym, modifier, isDown)
end;

function PumaEffects:update(dt)
end;

function PumaEffects:updateTick(dt)
	if self:getIsActive() then
		if self.isClient then
			if self.Puma.emitting then
				if self.Puma.emittTime >= self.Puma.allowedEmittTime then
					Utils.setEmittingState(self.Puma.motorStartPS, false);
					self.Puma.emittTime = 0;
				else
					self.Puma.emittTime = self.Puma.emittTime + dt;
				end;
			end;
		end;
	end;
end;

function PumaEffects:startMotor()
	if self:getIsActive() then
		if self.isClient then
			Utils.setEmittingState(self.Puma.motorStartPS, true);
			self.Puma.emitting = true;
		end;
	end;
end;

function PumaEffects:onTurnedOn()
	if self:getIsActive() then
		if self.isClient then
			Utils.setEmittingState(PumaEffects.Puma.motorStartPS, true);
			PumaEffects.Puma.emitting = true;
		end;
	end;
end;

function PumaEffects:draw()
end;

function PumaEffects:onAttachImplement(implement)
	if SpecializationUtil.hasSpecialization(Mower, implement.object.specializations) then
		Mower.onTurnedOn = Utils.overwrittenFunction(Mower.onTurnedOn, PumaEffects.onTurnedOn);
	end;
  
	if SpecializationUtil.hasSpecialization(Baler, implement.object.specializations) then
		Baler.onTurnedOn = Utils.overwrittenFunction(Baler.onTurnedOn, PumaEffects.onTurnedOn);
	end;
  
	if SpecializationUtil.hasSpecialization(Cultivator, implement.object.specializations) then
		Cultivator.onAiTurnOn = Utils.overwrittenFunction(Cultivator.onAiTurnOn, PumaEffects.onTurnedOn);
	end;
  
	if SpecializationUtil.hasSpecialization(MixerWagon, implement.object.specializations) then
		MixerWagon.onTurnedOn = Utils.overwrittenFunction(MixerWagon.onTurnedOn, PumaEffects.onTurnedOn);
	end; 
  
	if SpecializationUtil.hasSpecialization(RotorSpreader, implement.object.specializations) then
		RotorSpreader.onTurnedOn = Utils.overwrittenFunction(RotorSpreader.onTurnedOn, PumaEffects.onTurnedOn);
	end;
  
	if SpecializationUtil.hasSpecialization(SowingMachine, implement.object.specializations) then
		SowingMachine.onTurnedOn = Utils.overwrittenFunction(SowingMachine.onTurnedOn, PumaEffects.onTurnedOn);
	end;
  
	if SpecializationUtil.hasSpecialization(Sprayer, implement.object.specializations) then
		Sprayer.onTurnedOn = Utils.overwrittenFunction(Sprayer.onTurnedOn, PumaEffects.onTurnedOn);
	end;
  
	if SpecializationUtil.hasSpecialization(StumpCutter, implement.object.specializations) then
		StumpCutter.onTurnedOn = Utils.overwrittenFunction(StumpCutter.onTurnedOn, PumaEffects.onTurnedOn);
	end;
  
	if SpecializationUtil.hasSpecialization(Cultivator, implement.object.specializations) then
      Cultivator.onTurnedOn = Utils.overwrittenFunction(Cultivator.onTurnedOn, PumaEffects.onTurnedOn);
	end; 

	if SpecializationUtil.hasSpecialization(Windrower, implement.object.specializations) then
		Windrower.onTurnedOn = Utils.overwrittenFunction(Windrower.onTurnedOn, PumaEffects.onTurnedOn);
	end; 
	
	if SpecializationUtil.hasSpecialization(Tedder, implement.object.specializations) then
		Tedder.onTurnedOn = Utils.overwrittenFunction(Tedder.onTurnedOn, PumaEffects.onTurnedOn);
	end; 

	if SpecializationUtil.hasSpecialization(ForageWagon, implement.object.specializations) then
		ForageWagon.onTurnedOn = Utils.overwrittenFunction(ForageWagon.onTurnedOn, PumaEffects.onTurnedOn);
	end;

	if SpecializationUtil.hasSpecialization(ManureBarrel, implement.object.specializations) then
		ManureBarrel.onTurnedOn = Utils.overwrittenFunction(ManureBarrel.onTurnedOn, PumaEffects.onTurnedOn);
	end;
	
	if SpecializationUtil.hasSpecialization(ManureSpreader, implement.object.specializations) then
		ManureSpreader.onTurnedOn = Utils.overwrittenFunction(ManureSpreader.onTurnedOn, PumaEffects.onTurnedOn);
	end;
    
end;